Add tox.ini and few checker scripts
[csit.git] / resources / libraries / bash / function / common.sh
index db3d865..71cf9d3 100644 (file)
@@ -1,4 +1,4 @@
-# Copyright (c) 2018 Cisco and/or its affiliates.
+# Copyright (c) 2019 Cisco and/or its affiliates.
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
 # You may obtain a copy of the License at:
@@ -90,40 +90,43 @@ function activate_virtualenv () {
 
     set -exuo pipefail
 
+    # Update virtualenv pip package, delete and create virtualenv directory,
+    # activate the virtualenv, install requirements, set PYTHONPATH.
+
     # Arguments:
-    # - ${1} - Non-empty path to existing directory for creating virtualenv in.
+    # - ${1} - Path to existing directory for creating virtualenv in.
+    #          If missing or empty, ${CSIT_DIR} is used.
+    # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
     # Variables read:
     # - CSIT_DIR - Path to existing root of local CSIT git repository.
-    # Variables set:
-    # - ENV_DIR - Path to the created virtualenv subdirectory.
     # Variables exported:
     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
     # Functions called:
     # - die - Print to stderr and exit.
 
-    # TODO: Do we really need to have ENV_DIR available as a global variable?
-
-    if [[ "${1-}" == "" ]]; then
-        die "Root location of virtualenv to create is not specified."
-    fi
-    ENV_DIR="${1}/env"
-    rm -rf "${ENV_DIR}" || die "Failed to clean previous virtualenv."
+    # TODO: Do we want the callers to be able to set the env dir name?
+    # TODO: + In that case, do we want to support env switching?
+    # TODO:   + In that case we want to make env_dir global.
+    # TODO: Do we want the callers to override PYTHONPATH loaction?
 
+    root_path="${1-$CSIT_DIR}"
+    env_dir="${root_path}/env"
+    req_path=${2-$CSIT_DIR/requirements.txt}
+    rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
     pip install --upgrade virtualenv || {
         die "Virtualenv package install failed."
     }
-    virtualenv "${ENV_DIR}" || {
+    virtualenv "${env_dir}" || {
         die "Virtualenv creation failed."
     }
     set +u
-    source "${ENV_DIR}/bin/activate" || die "Virtualenv activation failed."
+    source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
     set -u
-    pip install -r "${CSIT_DIR}/requirements.txt" || {
-        die "CSIT requirements installation failed."
+    pip install --upgrade -r "${req_path}" || {
+        die "Requirements installation failed."
     }
-
     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
-    export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
+    export PYTHONPATH="${root_path}" || die "Export failed."
 }
 
 
@@ -415,11 +418,16 @@ function get_test_tag_string () {
                 ;;
             *"perf"*)
                 # On parsing error, ${trigger} stays empty.
-                trigger="$(echo "${GERRIT_EVENT_COMMENT_TEXT}" \
-                    | grep -oE '(perftest$|perftest[[:space:]].+$)')" \
-                    || true
+                comment="${GERRIT_EVENT_COMMENT_TEXT}"
+                # As "perftest" can be followed by something, we substitute it.
+                comment="${comment/perftest-2n/perftest}"
+                comment="${comment/perftest-3n/perftest}"
+                comment="${comment/perftest-hsw/perftest}"
+                comment="${comment/perftest-skx/perftest}"
+                tag_string="$(echo "${comment}" \
+                    | grep -oE '(perftest$|perftest[[:space:]].+$)' || true)"
                 # Set test tags as string.
-                TEST_TAG_STRING="${trigger#$"perftest"}"
+                TEST_TAG_STRING="${tag_string#$"perftest"}"
                 ;;
             *)
                 die "Unknown specification: ${TEST_CODE}"
@@ -555,7 +563,7 @@ function select_tags () {
             test_tag_array=("ndrpdrAND64bAND1c"
                             "ndrpdrAND78bAND1c")
             ;;
-        *"mrr-daily"* | *"mrr-weekly"* )
+        *"mrr-daily"* )
             test_tag_array=(# vic
                             "mrrANDnic_cisco-vic-1227AND64b"
                             "mrrANDnic_cisco-vic-1385AND64b"
@@ -637,12 +645,22 @@ function select_tags () {
                             # vm vhost ip4 base
                             "mrrANDvhostANDip4fwdANDbaseAND64b"
                             "mrrANDvhostANDip4fwdANDbaseANDimix"
+                            # DPDK
+                            "mrrANDdpdkAND64b"
                             # Exclude
                             "!mrrANDip6baseANDdot1qAND78b"
                             "!vhost_256ANDnic_intel-x520-da2"
                             "!vhostANDnic_intel-xl710"
                             "!cfs_opt"
-                            "!lbond_dpdk")
+                            "!lbond_dpdk"
+                            "!nf_density")
+            ;;
+        *"mrr-weekly"* )
+            test_tag_array=(# NF Density tests
+                            "mrrANDnf_densityAND64b"
+                            "mrrANDnf_densityANDimix"
+                            # DPDK
+                            "mrrANDdpdkAND64b")
             ;;
         * )
             if [[ -z "${TEST_TAG_STRING-}" ]]; then
@@ -780,7 +798,7 @@ function select_topology () {
             TOPOLOGIES=(
                         "${TOPOLOGIES_DIR}/lf_2n_skx_testbed21.yaml"
                         #"${TOPOLOGIES_DIR}/lf_2n_skx_testbed22.yaml"
-                        #"${TOPOLOGIES_DIR}/lf_2n_skx_testbed23.yaml"
+                        "${TOPOLOGIES_DIR}/lf_2n_skx_testbed23.yaml"
                         "${TOPOLOGIES_DIR}/lf_2n_skx_testbed24.yaml"
                        )
             TOPOLOGIES_TAGS="2_node_*_link_topo"